/*
PAYMENTS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package paymentsapi

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
)


// UnzerAPIService UnzerAPI service
type UnzerAPIService service

type ApiCreateUnzerConfigurationRequest struct {
	ctx context.Context
	ApiService *UnzerAPIService
	oid string
	createUnzerConfigRequest *CreateUnzerConfigRequest
}

func (r ApiCreateUnzerConfigurationRequest) CreateUnzerConfigRequest(createUnzerConfigRequest CreateUnzerConfigRequest) ApiCreateUnzerConfigurationRequest {
	r.createUnzerConfigRequest = &createUnzerConfigRequest
	return r
}

func (r ApiCreateUnzerConfigurationRequest) Execute() (*UnzerConfiguration, *http.Response, error) {
	return r.ApiService.CreateUnzerConfigurationExecute(r)
}

/*
CreateUnzerConfiguration Create Unzer configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiCreateUnzerConfigurationRequest
*/
func (a *UnzerAPIService) CreateUnzerConfiguration(ctx context.Context, oid string) ApiCreateUnzerConfigurationRequest {
	return ApiCreateUnzerConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
//  @return UnzerConfiguration
func (a *UnzerAPIService) CreateUnzerConfigurationExecute(r ApiCreateUnzerConfigurationRequest) (*UnzerConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *UnzerConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UnzerAPIService.CreateUnzerConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/unzer/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.createUnzerConfigRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiDeleteUnzerConfigurationRequest struct {
	ctx context.Context
	ApiService *UnzerAPIService
	oid string
}

func (r ApiDeleteUnzerConfigurationRequest) Execute() (*http.Response, error) {
	return r.ApiService.DeleteUnzerConfigurationExecute(r)
}

/*
DeleteUnzerConfiguration Delete Unzer configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiDeleteUnzerConfigurationRequest
*/
func (a *UnzerAPIService) DeleteUnzerConfiguration(ctx context.Context, oid string) ApiDeleteUnzerConfigurationRequest {
	return ApiDeleteUnzerConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
func (a *UnzerAPIService) DeleteUnzerConfigurationExecute(r ApiDeleteUnzerConfigurationRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodDelete
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UnzerAPIService.DeleteUnzerConfiguration")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/unzer/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}

type ApiGetUnzerConfigurationRequest struct {
	ctx context.Context
	ApiService *UnzerAPIService
	oid string
}

func (r ApiGetUnzerConfigurationRequest) Execute() (*UnzerConfiguration, *http.Response, error) {
	return r.ApiService.GetUnzerConfigurationExecute(r)
}

/*
GetUnzerConfiguration Get Unzer configuration



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param oid Organization ID
 @return ApiGetUnzerConfigurationRequest
*/
func (a *UnzerAPIService) GetUnzerConfiguration(ctx context.Context, oid string) ApiGetUnzerConfigurationRequest {
	return ApiGetUnzerConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		oid: oid,
	}
}

// Execute executes the request
//  @return UnzerConfiguration
func (a *UnzerAPIService) GetUnzerConfigurationExecute(r ApiGetUnzerConfigurationRequest) (*UnzerConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *UnzerConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UnzerAPIService.GetUnzerConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/integrations/unzer/organizations/{oid}/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"oid"+"}", url.PathEscape(parameterValueToString(r.oid, "oid")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
